#version 130

precision mediump float;

uniform mat4 pvm_eye;
uniform mat4 pvm_light;
uniform mat4 model;
uniform mat4 bias;

in vec4 vertex;
in vec4 color;
in vec3 normal;
in vec2 texCoord;

out vec4 frag_color;
out vec4 shadowCoord;
out vec2 texCoord0;
out vec3 world_normal;
out vec4 world_position;

void main()
{
	vec4 normal4 = vec4(normal, 0.0f);

	world_normal = (model * normal4).xyz;
    
	world_position = model * vertex;

	shadowCoord = bias * pvm_light * vertex;

	gl_Position = pvm_eye * vertex;

	texCoord0 = texCoord;

	frag_color = color;
}
